"""
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
"""

#!/usr/bin/python

"""
Converts a graph in Fredrik's dataset format to the
Pajek NET format, so that it can be visualized in Gephi.
"""

import sys

if len(sys.argv) != 2:
    print "usage: {} 100.txt".format(sys.argv[0])
    sys.exit(1)

graphfile = sys.argv[1]

# Print *vertices 2342
# Print *arcs
# 1 2 5
# 1 3 1231
f = open(graphfile, "r")
lines = f.read().splitlines()
f.close()

fromNodes   = map(float, [line.split()[0] for line in lines])
toNodes     = map(float, [line.split()[1] for line in lines])
edgeWeights = map(float, [line.split()[2] for line in lines])

numVerts = len(set(fromNodes + toNodes))

print "*vertices {}".format(numVerts)
print "*arcs"
for i in range(len(lines)):
    print "{} {} {}".format(int(fromNodes[i]), int(toNodes[i]), edgeWeights[i])



