"""
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
"""

#!/usr/bin/python

import glob
import os
import numpy as np
import sys

if len(sys.argv) != 2:
    print "usage: {} dataset_folder".format(sys.argv[0])
    sys.exit(1)

os.chdir(sys.argv[1])
files = glob.glob("*.txt")
print "Found {} graphs.".format(len(files))
num_nodes = []
num_edges = []
restart = False
for fil in files:
    nodes = set()
    f = open(fil, "r")
    lines = f.read().splitlines()
    f.close()
    for line in lines:
        try:
            a,b,c=line.split()
        except ValueError:
            restart=True
            break
        nodes.add(a)
        nodes.add(b)
    if restart:
        restart = False
        continue
    sys.stdout.write("{} ".format(len(nodes)))
    sys.stdout.flush()
    num_nodes.append(len(nodes))
    num_edges.append(len(lines)) # one edge per line

print ""
print "avg_nodes: {}".format(np.average(num_nodes))
print "avg_edges: {}".format(np.average(num_edges))
