"""
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
"""

#!/usr/bin/python

import sys
import random
import os

if len(sys.argv) != 3:
    print "usage: {} num_graphs folder_name".format(sys.argv[0])
    sys.exit(1)

num_graphs = int(sys.argv[1])
folder_name = sys.argv[2]

# Create link-graph
def create_link_graph(filename):
    num_vertices = int(100 + 10 * (random.random()-0.5)*2)
    weights = [random.random() * 12000.0 for i in range(num_vertices)]
    f = open(filename, "w")
    for i in range(num_vertices-1):
        f.write("{} {} {}\n".format(i, i+1, weights[i]))
    f.close()

# Create complete graph
def create_complete_graph(filename):
    num_vertices = int(100 + 10 * (random.random()-0.5)*2)
    weights = [random.random() * 12000.0 for i in range(num_vertices)]
    f = open(filename, "w")
    for i in range(num_vertices):
        for j in range(i+1, num_vertices):
            f.write("{} {} {}\n".format(i, j, weights[j]))
    f.close()

num_pos = num_graphs/2
num_neg = num_graphs-num_pos
os.system("mkdir -p \"{}\"".format(folder_name))
labelFile = open("{}/labels.txt".format(folder_name), "w")
for i in range(num_pos):
    labelFile.write("1\n") # Link graph
    graphname = "{}/{}.txt".format(folder_name, i+1)
    create_link_graph(graphname)
for i in range(num_neg):
    labelFile.write("-1\n") # Link graph
    graphname = "{}/{}.txt".format(folder_name, num_pos + i+1)
    create_complete_graph(graphname)
labelFile.close()

