"""
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
"""

#!/usr/bin/python

"""
Creates one IMDB local neighborhood graph for the given actor_id.
k_max is the k of the k-neighborhood.
"""

if __name__ == "__main__":

    import time
    import sys
    reload(sys)
    sys.setdefaultencoding("utf-8")
    import extractNeighborhood

    if len(sys.argv) != 6:
        print "usage: {} actor_id label k adjlist_rf_format.txt output_folder".format(sys.argv[0])
        sys.exit(1)

    actor_id = sys.argv[1]
    lbl = int(sys.argv[2])
    k = int(sys.argv[3])
    adjlist_rf_format_filename = sys.argv[4]
    output_folder = sys.argv[5]

    #if not lbl in [1,-1]:
    #    print "Label must be 1 or -1!"
    #    sys.exit(1)

    print "actor_id:", actor_id
    print "label",lbl
    print "Extracting {}-neighborhood.".format(k)
    extractNeighborhood.extract_neighborhood(actor_id, k, adjlist_rf_format_filename, output_folder + "/{}.k{}.{}.txt".format(actor_id, k, lbl))

