"""
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
"""

#!/usr/bin/python

import numpy as np

def get_max_in_degree(A):
    indeg = np.sum(A, 0)
    return np.max(indeg)

def get_max_out_degree(A):
    outdeg = np.sum(A, 1)
    return np.max(outdeg)

def get_max_degree(A):
    return np.max([get_max_out_degree(A), get_max_in_degree(A)])

def get_good_lambda(A):
    # lambda < 1/a, where a >= max_degree(A)
    a = get_max_degree(A)
    lamb = 1.0 / (a + 1.0)
    return lamb
