"""
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
"""

#!/usr/bin/python

import time

class Timer(object):
    def __init__(self, total_elems=0):
        self.total_elems = total_elems

    def start(self):
        self.start_time = time.time()

    def get_eta(self, num_processed_elems):
        elapsed = self.get_elapsed()
        if elapsed != 0:
            speed = num_processed_elems / elapsed
        else:
            speed = 0

        if speed != 0:
            eta = (self.total_elems - num_processed_elems) / float(speed)
        else:
            eta = float("inf") # Well, since we are not moving forward at all, are we? :)

        return eta

    def get_elapsed(self):
        return time.time() - self.start_time

    def format(self, seconds):
        seconds = int(seconds)
        h = seconds / 3600
        seconds %= 3600
        m = seconds / 60
        seconds %= 60
        s = seconds
        return "{:02}:{:02}:{:02}".format(h,m,s)

