"""
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
"""


#!/bin/bash

EXPECTED_ARGS=2
E_BADARGS=65

if [ $# -ne $EXPECTED_ARGS ]; then
    echo "Usage: `basename $0` job_pattern job_ex_num"
    exit $E_BADARGS
fi

JOBID=$2
COUNT=1
for FILE in `ls $1`
do
    CURR_JOB="job_ex${JOBID}_${COUNT}"
    PREV_JOB="job_ex${JOBID}_$((COUNT-1))"
    if [[ $COUNT -eq 1 ]]; then
        HOLD=''
    else
        HOLD="-hold_jid $PREV_JOB"
    fi

    echo qsub -N $CURR_JOB $HOLD $FILE
    COUNT=$((COUNT+1))
done
