"""
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
"""


import rfQuery

def getEntityId(pname):
	#q = { "entity": { "name": pname, "type": "Person" } }
        q = { "entity": { "name": pname} }

	d = rfQuery.submitQuery(q)
	# print(d)
	if(d['status'] == 'SUCCESS'):
		maxHits = 0
		entId = ''
		for e in d['entity_details']:
			ent = d['entity_details'][e]
			hits = ent['hits']
			if hits > maxHits:
				entId = e
				maxHits = hits
		return entId
	else:
		return d

def getEntityName(id,onlyPerson=False):
	q = { "entity": { "id": id} }

	d = rfQuery.submitQuery(q)
	# print(d)
	if(d['status'] == 'SUCCESS' and 'entity_details' in d and id in d['entity_details']):
		if((not onlyPerson) or d['entity_details'][id]['type'] == 'Person'):
			return d['entity_details'][id]['name']
		else:
			return ""
	else:
		return ""
