"""
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
"""


import json
#from urllib.parse import urlencode
#from urllib.request import urlopen
import urllib

URL = 'http://api.recordedfuture.com/query?%s'
DEFAULT_TOKEN = '9EbBBB' #This is Linus token

def submitQuery(query_string):
	if isinstance(query_string,dict):
		try:
			if not 'token' in query_string:
				query_string['token'] = DEFAULT_TOKEN
			query_string = query2string(query_string)
			#print(query_string)
		except Exception as e:
			return "submitQuery: Error converting dict to string"
	try:
		#print({"q":str(query_string)})
		data = urllib.urlopen(URL % urllib.urlencode({"q":str(query_string)}))
		#print(type(data))
		if type(data) != str:
			# Note that data.read() can only be done once.
			read_data = data.read()
			return json.loads(read_data.decode('latin-1'))
		return "Error";
	except Exception as e:
		return {'status': 'FAILURE', 'errors': str(e)}

def query2string(query_dict):
	return '"'.join(str(query_dict).split("'"))
