"""
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
"""



import json
#from urllib.parse import urlencode
#from urllib.request import urlopen
import urllib

URL = 'http://api.recordedfuture.com/query?%s'
DEFAULT_TOKEN = '9EbBBB' #This is Linus' token

def submitQuery(query_string):
	if isinstance(query_string,dict):
		try:
			if not 'token' in query_string:
				query_string['token'] = DEFAULT_TOKEN
                        print "QString b4 string " + str(query_string)
			query_string = query2string(query_string)
                        print (type (query_string))
			print "QString after string"
                        print query_string
                        #proof = "{"instance": {"attributes": {"entity": {"id": "B_FCc"}}, "start_time": "2009-09-01", "limit": 1, "stop_time": "2009-10-01"}, "token": "9EbBBB"}"

                        #print proof
		except Exception as e:
			return "submitQuery: Error converting dict to string"
	try:
                print "ULRL encoded string " + str(urllib.urlencode({"q":str(query_string)}))
                print "Submitted QString " + str(URL % urllib.urlencode({"q":str(query_string)}))
		data = urllib.urlopen(URL % urllib.urlencode({"q":str(query_string)}))

                #data = urllib.urlopen(URL % urllib.urlencode( ))
		#print(type(data))
		if type(data) != str:
			# Note that data.read() can only be done once.
			read_data = data.read()
			return json.loads(read_data.decode('latin-1'))
		return "Error";
	except Exception as e:
		return {'status': 'FAILURE', 'errors': str(e)}


def getEntityByName(pname):
	#q = { "entity": { "name": pname, "type": "Person"} }
        q = { "entity": { "name": pname} }

	d = submitQuery(q)
	print "Full response to query"
	print(d)
	print "Type of response"
	print type(d)
	if(d['status'] == 'SUCCESS'):
		maxHits = 0
		entId = ''
		for e in d['entity_details']:
			ent = d['entity_details'][e]
		return entId
	else:
		return d

def getEntityById(id,onlyPerson=False):
	q = { "entity": { "id": id} }

	d = submitQuery(q)
	print "Full response to query"
	print(d)
	if(d['status'] == 'SUCCESS' and 'entity_details' in d and id in d['entity_details']):
		if((not onlyPerson) or d['entity_details'][id]['type'] == 'Person'):
			return d['entity_details'][id]['name']
		else:
			return ""
	else:
		return ""

def getInstance(instance_id):

        q=        {
          "instance": {
            "id":instance_id,
            "limit": 100
          }
         }

        print (type (q))
        print q
 
	d = submitQuery(q)
	print "Full response to query"
	print(d)
	print "Ordered repsonse to query"
	for key in d:
		print key
		print d[key]
        
	print "\n ENTITES \n"
	for e in d["entities"]:
                print "NEW ENTITY ============================"
		print e
		print d["entities"][e]


        print "\n INSTANCES \n"
        for i in d["instances"]:
                print "NEW INSTANCE-----------------------"                
                print i


	if(d['status'] == 'SUCCESS' and 'entity_details' in d and id in d['entity_details']):
		if((not onlyPerson) or d['entity_details'][id]['type'] == 'Person'):
			return d['entity_details'][id]['name']
		else:
			return ""
	else:
		return ""

def getDocument(doc_id):
        
        #q = { "instance": {"entity":{"id":"B_FCc"}},
        #         "document":{"id": doc_id}}


        q=        {
          "instance": {
            "document":{"id":doc_id},
            "limit": 100
          }
         }

        print (type (q))
        print q
 
	d = submitQuery(q)
	print "Full response to query"
	print(d)
	print "Ordered repsonse to query"
	for key in d:
		print key
		print d[key]
        
	print "\n ENTITES \n"
	for e in d["entities"]:
                print "NEW ENTITY ============================"
		print e
		print d["entities"][e]


        print "\n INSTANCES \n"
        for i in d["instances"]:
                print "NEW INSTANCE-----------------------"                
                print i


	if(d['status'] == 'SUCCESS' and 'entity_details' in d and id in d['entity_details']):
		if((not onlyPerson) or d['entity_details'][id]['type'] == 'Person'):
			return d['entity_details'][id]['name']
		else:
			return ""
	else:
		return ""
        

def getSource():

	#q = { "event" : {"type" : "Quotation",  } }

	
        q=        {
                    "instance":
                    {                     
                        "entity":
                        {
                            "id": "J4LP5h"
                        }
                    }
                }


        print (type (q))
        print q
        
	"""

	q={
	  "instance": {
	    "type": "EntityOccurrence",
	    "attributes": {
	      "entity": {
		"id": "B_FCc"
	      }
	    }
	   "document": {
	      "published": {"min": "2010-01-01", "max": "2010-02-01"}
	    },
	    "limit": 5
	  },
	  "token": "TOKEN"
	 }
	"""
	"""
	q={
	  "comment": "Barack Obama quotations.",
	  "instance": {
	    "type": "Quotation",
	    "attributes": {
	      "entity": {
		"id":"B_FCc"
	      }
	    },
	    "limit": 3
	  }
	}
	"""	 
	
	d = submitQuery(q)
	print "Full response to query"
	print(d)
	print "Ordered repsonse to query"
	for key in d:
		print key
		print d[key]

	print "\n ENTITES \n"
	for e in d["entities"]:
		print e
		print d["entities"][e]

	print "====================="
	print "====================="
	print "====================="
	print "====================="
	print "LIST OF ONLY ENTITIES"
	print "====================="
	print "====================="
	print "====================="
	print "====================="
	for e in d["entities"]:
		print e
	print d["entities"]["J4LP5h"]


	if(d['status'] == 'SUCCESS' and 'entity_details' in d and id in d['entity_details']):
		if((not onlyPerson) or d['entity_details'][id]['type'] == 'Person'):
			return d['entity_details'][id]['name']
		else:
			return ""
	else:
		return ""


def query2string(query_dict):
	return '"'.join(str(query_dict).split("'"))


