/**
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
 * @section DESCRIPTION
 *
 * Common exceptions.
 */
#ifndef MTLT_EXCEPTION_HPP
#define MTLT_EXCEPTION_HPP

#include <exception>

class MtltQuitException : public std::exception {
    public:

        MtltQuitException(std::string _reason) : std::exception(), reason(_reason) {
        }

        virtual ~MtltQuitException() throw() {}

        virtual const char* what() const throw() {
            return reason.c_str();
        };

    private:

        std::string reason;
};


#endif
