/**
 * @file
 * @author  Tommi Kerola <kerola@student.chalmers.se>
 * @author  Linus Hermansson <hlinus@student.chalmers.se>
 * @version 1.0
 *
 * @section LICENSE
 *
 * Copyright [2013] [Tommi Kerola, Linus Hermansson]
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
 * @section DESCRIPTION
 *
 * This file contains the starting point of the program.
 */
#ifndef MAIN_HPP
#define MAIN_HPP

// Standard includes
#include <iostream>
#include <map>
#include "sparse_vector.hpp"

#include "helper.hpp"
#include "graph_loader.hpp"

#include "shortest_path_program.hpp"
#include "random_walk_program.hpp"

#include "shortest_path_graph.hpp"
#include "shortest_path_kernel.hpp"
#include "random_walk_kernel.hpp"

#endif
