#This script is used in order to extract 1000 nodes that should be used in disambiguation by the malin
#algorithm. 
#ONLY TAKES ACTORS THAT HAVE BEEN IN MORE THAN 1 MOVIE

import sys
from collections import defaultdict

def main():

	file = open ("../../../../Dropbox/masters_thesis_project/graphs/imdb9403/imdb_amb_adjlist_malin.txt"  ,"r")
	debug = True
	ambiguity_number = dict()
	sources = defaultdict(list)
	node_sources = defaultdict(list)
	while True:
		line = file.readline()
		if line == "":
			break	
		
		line = line.split()
		int_line = map(int,line)
		node = int_line[0]
		
		int_line.pop(0) #the node 
		#will not cover nodes that do not have their own line
		ambiguity_number[node] = int_line[0]
		int_line.pop(0) #the ambiguity number
		if len(int_line) == 0 & node not in node_sources:
			node_sources[node] = []
			continue	

		i = 0
		while i < (len(int_line)):
			to_node = int_line[i]
			source = int_line[i+1]
			sources[source].append(node)
			sources[source].append(to_node)
			node_sources[node].append(source)
			node_sources[to_node].append(source)
			i = i+2	

	file.close()	

	print "Done reading file"

	#remove duplicates, this method is faster than only inserting non-duplicates
	#sources = list(set(sources))
	max_nodeid = max(node_sources)
	num_sources = len(sources)
	
	num_solo_movies = 0
	for s in sources:
		if len(sources[s]) == 1:
			num_solo_movies += 1
	
	print "Removing duplicates in sources"
	
	for source in sources:
		sources[source] = list(set(sources[source]))

	print "Removing duplicates in node sources"
	for ns in node_sources:
		node_sources[ns] = list(set(node_sources[ns]))

	num_nodes = len(node_sources)
	num_nodes_noline = num_nodes - len(ambiguity_number)
	print num_nodes
	print num_sources
	print num_solo_movies
	print num_nodes_noline

	print "Writing to file"
	file = open("new_1000graphs.txt", "w+")
	#file.write("Testing \n asd")
	i = 1
	counter500pos = 0
	counter500neg = 0
	for ns in node_sources:
		
		if len(node_sources[ns]) > 1 and ns in ambiguity_number and ambiguity_number[ns] > 1 and counter500pos < 500 :
			file.write(str(ns) + " ")
			file.write("1")
			file.write("\n")
			counter500pos += 1
			if counter500pos == 500 and counter500neg == 500:
				break			
		
		
		if len(node_sources[ns]) > 1 and ns in ambiguity_number and ambiguity_number[ns] == 1 and counter500neg < 500:
			file.write(str(ns) + " ")
			file.write("-1")
			file.write("\n")
			counter500neg += 1
			if counter500pos == 500 and counter500neg == 500:
				break

if __name__=="__main__":
	main()
