import random
import sys
import time
import math
import numpy as np
from collections import defaultdict

def main():
	
	#There are currently 214 514 nodes in outputfile
	#There are currently 289 432 sources in outputfile
	#Malin had ca 180 000 nodes and 37 000 sources
	debug = False

	homemade_random_on = True
	prob_random_on = False
	numpy_random_on = False

	if homemade_random_on:
		print "Homemade randomness"
	if prob_random_on: 
		print "Probability sum randomness"
	if numpy_random_on:
		print "Numpy randomness"

	half_debug = False | debug
	test_probs = True
	file_ambiguity_included = True
	

	print "Program starting"
	if len(sys.argv) != 6:
		print "usage: main num_walks input_file to_classify_file walks_outputfile num_steps"
		sys.exit(1)

	num_walks = int(sys.argv[1])
	#num_walks = 10
	#num_steps = 50
	num_steps = int(sys.argv[5])

	print "Number of walks " + str(num_walks)
	print "Number of steps " + str(num_steps)

	#num_steps = int(sys.argv[2])
	#threshold = float(sys.argv[1])	
	file_name = sys.argv[2]
	to_classify_file = sys.argv[3] #the file containing the nodes to be ambiguated.
	outfile = sys.argv[4]
	walks_outputfile = open(outfile, "w+")
	#Parse the file to get all the info
	nodes = []
	file_representation = defaultdict(list)
	to_ambiguate = []
	print "The file that contained the graphs to classify " + str(to_classify_file)
	

	file_a = open(to_classify_file, "r")
	
	while True:
		line = file_a.readline()
		if line == "":
			break
		line = line.split()
		int_line = map(int,line)
		to_ambiguate.append( (int_line[0], int_line[1]) )
		
	if half_debug:
		print to_ambiguate

	num_to_ambiguate = len(to_ambiguate)
	start_time = time.time() 

	print "Number of graphs to ambiguate " + str(num_to_ambiguate)
	#to_classify = 1 #the node to be split and then classified using RW

	file = open(file_name, "r")
	sources = []
        #j = 0
	while True:
                #if j % 10000 == 0:
                #        print j / float(214514)  
		line = file.readline()
		if line == "":
			break	
		
		line = line.split()
		int_line = map(int,line)
		node = int_line[0]
		nodes.append(node)

		#int_line = [int(i) for i in line]
		#print "int line " + str(int_line)
		int_line.pop(0) #the node 
		if len(int_line) == 0:
			continue
		if file_ambiguity_included:
			#if node == to_classify:
			#	ambi_number = int_line[0]
			#	print "Amibiguity number " + str(ambi_number) 
			int_line.pop(0) #the ambiguity number

		i = 0
		#print int_line
		#file_representation[node] = []
		while i < (len(int_line)):
			#print "i " + str(i)
			to_node = int_line[i]
			source = int_line[i+1]
			sources.append(source)
			#print "to node and source " + str(to_node) + " " +  str(source)
			file_representation[node].append( (to_node, source) ) 
			i = i+2	
                #j+=1
	file.close()
	
	#remove duplicates, this method is faster than only inserting non-duplicates
	sources = list(set(sources))
	max_nodeid = max(nodes)
	num_nodes = len(nodes)
	num_sources = len(sources)
	
	#remove duplicates
	for f in file_representation:
		temp = file_representation[f]
		file_representation[f] = list(set(temp))

	if debug:
		print "number of nodes " + str(num_nodes)
		print "number of sources " + str(num_sources) 

	weights = dict()
	total_cocastings = dict()
	

	if debug:
		print "file representation " + str(file_representation)

	#Calculate the weights
	
	for node_info in file_representation:
		temp_weights = defaultdict(int)
		temp_total_cocastings = 0
		 
		for info in file_representation[node_info]:
			temp_weights[info[0]] += 1
			temp_total_cocastings += 1

		total_cocastings[node_info] = temp_total_cocastings
		weights[node_info] = temp_weights.copy()


	if debug:
		print "weights " + str(weights)
		print "total cocastings " + str(total_cocastings)


	#Not used anymore
	num_neighbours = dict()
	for node_weights in weights:
		temp_sum = 0
		for weight in weights[node_weights]:
			if weights[node_weights][weight] != 0:
				temp_sum += 1	
			else:
				print "should never be zero"
		num_neighbours[node_weights] = temp_sum
	
	if debug:	
		print "num_neighbours " + str(num_neighbours)

	#normalize the weights and the total_cocastings
	for node_weights in weights:
		for weight in weights[node_weights]:
			weights[node_weights][weight] /= float(num_sources)
	if debug:
		print "normalized weights " + str(weights)

	normalized_total_cocastings = dict()

	for node_total in total_cocastings:
		normalized_total_cocastings[node_total] = total_cocastings[node_total] / float(num_sources)

	if debug:
		print "normalized total cocastings " + str(total_cocastings)	

	#calculate the probability of walking from one node to another
	walk_probabilities = dict()
	for node_weights in weights:
		walk_probabilities[node_weights] = dict()
		for weight in weights[node_weights]:
			if weights[node_weights][weight] != 0:
				walk_probabilities[node_weights][weight] = weights[node_weights][weight] / normalized_total_cocastings[node_weights]
			else:
				print "Error something is wrong if there is a 0 weight"

	#print "Debugging 17186 " + str(walk_probabilities[17186])

	if debug:
		print "walk probabilities " + str(walk_probabilities) 	

	#split the node that should be classified


	#START#START#START#START#START#START#START#START#START#START#START#START#START#START
	#START#START#START#START#START#START#START#START#START#START#START#START#START#START
		
	file_representation2 = file_representation.copy()
		
	walk_probabilities2 = dict()
	for walk_prob in walk_probabilities:
		walk_probabilities2[walk_prob] = walk_probabilities[walk_prob].copy()

	#for node in walk_probabilities:
#		update_probability_sum(probability_sum, walk_probabilities, node)
		


	true_pos = 0
	true_neg = 0
	false_pos = 0
	false_neg = 0
	
	random.seed(12345)
	print "First random number " + str(np.random.random_sample()) 
	num_one_source = 0
	walk_time = 0
	prob_time = 0
	

	start_time_loop = time.time()

	tot_amb_file = len(to_ambiguate)
	for amb_file_index, ambi_from_file in enumerate(to_ambiguate):
		
		print "starting to classify node " + str(ambi_from_file[0])
		
		file_representation = file_representation2.copy()
		probability_sum = dict()
	
		walk_probabilities = dict()
		for walk_prob in walk_probabilities2:
			walk_probabilities[walk_prob] = walk_probabilities2[walk_prob].copy()
		#print "Debugging 17186 " + str(walk_probabilities[17186])
		#print "Walk probs " + str(walk_probabilities)
		#print "Walk probs2 " + str(walk_probabilities)
		to_classify = ambi_from_file[0]
		label = ambi_from_file[1]	
		line_sources = get_line_sources(to_classify, file_representation[to_classify])
		if half_debug:
			print "line sources" + str(line_sources)	

		i = 0
		for source in line_sources:
			i = i+1
			new_nodeid = max_nodeid+i
			walk_probabilities[new_nodeid] = dict()
			for connected_node in line_sources[source]:			
				if connected_node == to_classify:
					continue	
				walk_probabilities[new_nodeid][connected_node] = 1/float(len(line_sources[source] )-1 )
				walk_probabilities[connected_node][new_nodeid] = 1/float(total_cocastings[connected_node])

		#
		#update_probability_sum(probability_sum, walk_probabilities, to_classify)


		#No point in doing the walks since we know it will be predicted as 1 entity.
		if i == 1:
			num_one_source += 1
			print "Only one source, predicting one entity"
			

			#Print to file
			walks_outputfile.write(str(to_classify))
			walks_outputfile.write(" " + str(label))
			walks_outputfile.write(" -1 -1 -1")
			walks_outputfile.write("\n")

			if label == 1:
				print "Impossible to predict, one source but ambiguous"
			predicted_num_entries = 1
			if predicted_num_entries == 1:
				predicted_label = -1
			else:
				predicted_label = 1

			#True positive
			if predicted_label == label and label == 1:
				true_pos += 1
			#True negative
			elif predicted_label == label and label == -1:
				true_neg += 1
			#False negative
			elif predicted_label != label and label == 1:
				false_neg += 1
			#False positive
			elif predicted_label != label and label == -1:
				false_pos += 1
			else:
				print "ERROR:: NOT CLASSIFYABLE"
			continue
			

		#if debug:
		#	print "updated walk probs " + str(walk_probabilities)		
		#if half_debug:
		#	print "the node has this many sources " + str(len(line_sources)) 

		#remove the obsolete walk probabilities
		#can be done better by extracting neighbours of to_classify
		del walk_probabilities[to_classify]

		#if to_classify in probability_sum:
		#	del probability_sum[to_classify]

		for node in walk_probabilities:
			obsolete = False
			for to_node in walk_probabilities[node]:
				if to_node == to_classify:
					obsolete = True
			if obsolete:
				del walk_probabilities[node][to_classify]
				#if node in probability_sum:
				#	del probability_sum[node]	

		#if half_debug:
		#	print "finished walk probs " + str(walk_probabilities)


		ambi_nodes = []
		for i in range(max_nodeid+1, max_nodeid+1+len(line_sources)):
			ambi_nodes.append(i)
		#if debug:
		#	print "ambi nodes " +  str(ambi_nodes)

		#Perform the random walks
	
		
		walk_count = dict()
		walk_start_time = time.time()
		for start_node in ambi_nodes:
			#if counter % 2 == 0:
			#	v = counter / float(time.time() - walk_start_time)
			#	t = (len(ambi_nodes)-counter) / float(v)
			#	print t
			#if debug:
			#	print "start node " + str(start_node) 
			temp_walk_count = dict()
			ambi_nodes_dict = dict()
			for node in ambi_nodes:
				if node != start_node:
					temp_walk_count[node] = 0
						
			walk = 1
			for walk in range(1, num_walks+1):
			#while walk < num_walks+1:
				#print walk
				#print "Starting new walk ----------------"
				current_node = start_node
				#break_bool = False
				for step in range(1,num_steps+1):
					en_list = list(enumerate(walk_probabilities[current_node]))
					#en_array = np.zeros( len(walk_probabilities[current_node]) )
					#k = 0
					#for wp in walk_probabilities[current_node]:
					#	en_array[k] = wp
					#	k += 1


					#print "current node and en_list " + str(current_node) + str(en_list)
					#i = 1
					"""
					if test_probs:
						test = 0.0
						num_acc = 0
						num_not_acc = 0
						for n in walk_probabilities[current_node]:
							test += walk_probabilities[current_node][n]
						if math.fabs(test - 1.0) > 0.01: 
							print "NOT ACCURATE PROBABILITY  " + str(test)
							print "Current node " + str(current_node)
							num_not_acc += 1
						else:
							#print "ACCURATE PROB "
							num_acc += 1
						if num_acc > 0:
							acc = (num_acc + num_not_acc) / float(num_acc)
						else:
							acc = 0
						if acc < 1.0:
							print "Percent that had accurate probability " + str(acc)
					
					"""
					prob_start_time = time.time()	
					rndm = np.random.random()
					
					#using home made randomness
					#if homemade_random_on:
					
					temp_sum = 0.0
					chosen = -1
					for to_node in walk_probabilities[current_node]:
						chosen += 1
						temp_sum += walk_probabilities[current_node][to_node]
						if rndm <= temp_sum:
							break
					
					#using home made randomness with probability_sum
					#if prob_random_on:
					"""	
					chosen = -1
					if current_node not in probability_sum:
						update_probability_sum(probability_sum,walk_probabilities ,current_node)
					for i in range(0, len(probability_sum[current_node])):
						chosen += 1
						if rndm <= probability_sum[current_node][i]:
							break
							#print "This should never be printed"
						#if i == len(probability_sum[current_node])-1:
						#	print i
						#	print rndm
						#	print probability_sum[current_node]
						#	print "Major missunderstanding"
					
					"""
					#using numpy random
					#if numpy_random_on:
					"""
					probabilities = to_list(walk_probabilities[current_node])
					random_result = np.random.multinomial(1, probabilities, size = 1)	
					chosen = get_one_index(random_result)
					"""
					#End of randomness	


					prob_time += (time.time() - prob_start_time)
					current_node = en_list[chosen][1]
					#current_node = en_array[chosen]

					#print "Current node " + str(current_nod)
					#if ambi_nodes.count(current_node) == 1 and current_node != start_node:
						#print "temp walk and current node " + str(temp_walk_count) + " " + str(current_node)		
					#here temp_walk_count is used as a O(1) lookup to find ambi_nodes
					if current_node in temp_walk_count:
						#print "Found stopping point"
						temp_walk_count[current_node] += 1
						break


				

			walk_count[start_node] = temp_walk_count.copy()		
		#if half_debug:					
		#	print "walk count " + str(walk_count)
		
		walk_time += (time.time() - walk_start_time)

		#Done with random walks
		#normalize

		#print "walk count " + str(walk_count)

		for start_node in walk_count:
			successful_walks = 0
			for to_node in walk_count[start_node]:
				successful_walks += walk_count[start_node][to_node] 
			for to_node in walk_count[start_node]:
				#walk_count[start_node][to_node] /= float(num_walks)
				if successful_walks > 0:
					walk_count[start_node][to_node] /= float(successful_walks)

			#if debug:
			#	print "# Succ Walks " + str(successful_walks)

		#if half_debug:
		#	print "normalized walk_count " + str(walk_count)

		#Create the posterior probability graph

		#The simularity between two edges is their average posterior prob

		for start_node in walk_count:
			for to_node in walk_count[start_node]:
				temp = walk_count[start_node][to_node]
				walk_count[start_node][to_node] = (temp + walk_count[to_node][start_node]) / 2.0
				walk_count[to_node][start_node] = (temp + walk_count[to_node][start_node]) / 2.0


		
		#Print to file
		walks_outputfile.write(str(to_classify))
		walks_outputfile.write(" " + str(label))
		#print "Walk count: " + str(walk_count)
		for wc in walk_count:
			for to_node in walk_count[wc]:
				walks_outputfile.write(" " + str(wc))
				walk_count_out = '%.20f' % walk_count[wc][to_node]
				walks_outputfile.write(" " + str(to_node) + " " + walk_count_out )
		walks_outputfile.write("\n")
			
		#THE COMMENT SHOULD START HERE TO REMOVE CLASSIFICATION FROM THIS PROGRAM		
		"""

		for start_node in walk_count:
			to_remove = []
			for to_node in walk_count[start_node]:
				#LEQ only for the special case when threshold = 0.00000
				if walk_count[start_node][to_node] <= threshold:
					to_remove.append(to_node)
			for remove in to_remove:
				del walk_count[start_node][remove]			

		#Create the clusters
		clusters = dict()
		print "walk count " + str(walk_count)
		print "Num neighbours " + len(walk_count) 
		for node in walk_count:
			clusters[node] = set(get_new_neighbours(node, walk_count, [node]))

		#if True:
		#	print "Clusters " + str(clusters)		

		#Calculate final clusters (Remove duplicates)
		final_clusters = []
		for index in clusters:
			already_there = False
			for f_cluster in final_clusters:
				if f_cluster == clusters[index]:
					already_there = True
			if not already_there:
				final_clusters.append(clusters[index])
				
		#if True:
		#	print "final clusters " + str(final_clusters)
		print "Predicted number of entities " + str(len(final_clusters)) + " The correct label " + str(label)

		predicted_num_entries = len(final_clusters)
		if predicted_num_entries == 1:
			predicted_label = -1
		else:
			predicted_label = 1

		#True positive
		if predicted_label == label and label == 1:
			true_pos += 1
		#True negative
		elif predicted_label == label and label == -1:
			true_neg += 1
		#False negative
		elif predicted_label != label and label == 1:
			false_neg += 1
		#False positive
		elif predicted_label != label and label == -1:
			false_pos += 1
		else:
			print "ERROR:: NOT CLASSIFYABLE"


	#THE COMMENT SHOULD STOP HERE


	#End of classifying one node

		#Calculate the accuracy
	acc_sum = 0
	acc_sum += true_pos
	acc_sum += true_neg

	accuracy = acc_sum/(float(num_to_ambiguate))	
	
	print "True positives " + str(true_pos)
	print "True negatives " + str(true_neg)
	print "False positives " + str(false_pos)
	print "False negatives " + str(false_neg)
	print "Total number to ambiguate " + str(num_to_ambiguate)
	print "Accuracy " + str(accuracy)
	"""
	
	print "time spent on walks " + str(walk_time)
	print "time spent on probability " + str(prob_time)
	print "percent of time spent on prob " + str(prob_time / walk_time)
	print "Number of classified nodes that had only one source " + str(num_one_source)
	end_time = time.time()
	print "Total running time " + str(end_time - start_time)  
	

def get_line_sources(node, file_info):
	sources = dict()
	for connection in file_info:
		source_id = connection[1]
		to_node = connection[0]
		if source_id in sources:
			temp = sources[source_id]
			temp.append(to_node)
			sources[source_id] = temp
		else:
			sources[source_id] = [node, to_node]
	return sources

def get_ambi_sources(to_classify, classify_sources):
	ambi_sources = []
	for source_info in classify_sources:
		source = source_info[1]
		if ambi_sources.count(source) == 0:
			ambi_sources.append(source_info)
	return ambi_sources

def get_new_neighbours(node, walk_count, already_found):
	print "node "  + str(node)
	for neighbour in walk_count[node]:
		print "nei " + str(neighbour)
		if already_found.count(neighbour) == 0:
			print "new neig " + str(neighbour)
			already_found.append(neighbour)
			print "found so far " + str(already_found)
			temp = get_new_neighbours (neighbour, walk_count, already_found) 
			print "temp " + str(temp)
			
			already_found.extend(temp)
			already_found = list(set(already_found))
			print "set list " + str(already_found)

	return already_found

def to_list(walk_probs):
	result = []
	for index in walk_probs:
		result.append(walk_probs[index])
	return result

def get_one_index(array):	
	i = 0
	array = array[0]
	for elem in array:
		if elem == 1:
			return i
		i += 1
	raise Exception("No 1 in the probabilities")

def update_probability_sum(probability_sum, walk_probabilities, node):
	probability_sum[node] = np.zeros(len(walk_probabilities[node]) )
	i = 0
	for to_node in walk_probabilities[node]:
		if i > 0:
			probability_sum[node][i] += probability_sum[node][i-1]
		probability_sum[node][i] += walk_probabilities[node][to_node]	
		i += 1


if __name__=="__main__":
	main()
